#pragma once
#include "afxcmn.h"
#include "afxdtctl.h"
#include "swallow.h"
#include "afxwin.h"


// CFileQueryDlg dialog

struct STR_DownloadPos
{
	int iPageNo;
	unsigned int uiDownloadID[10];
	CString cRemoteFileName;
	int iSelectRowNo;
	int iPos;// [OUT]ļĽ(0~100)
	int iDownLoadSize;// [OUT]ļĴС
	int iFileSize; //ļܴС
};

class CFileQueryDlg : public CDialog
{
	DECLARE_DYNAMIC(CFileQueryDlg)

public:
	CFileQueryDlg(CWnd* pParent = NULL); 
	virtual ~CFileQueryDlg();

	enum { IDD = IDD_DIALOG_FILEQUERY };

public:
//	PlayStatus			m_LocalPlayStatus;			//״̬
	LVCOLUMN			m_lvItem;
	STR_DownloadPos		m_strDownLoadPos;			//ѯϢṹ
	CString				m_cstrFilePath;				//ļ洢·
	CString				m_cstrNvsIP;					//ǰnvsIP
	CString				m_cstrSavePath;				//·
	CString				m_cstrPlayRemoteBegainTime;	//ǰΰʱطſʼʱ
	CString				m_cstrPlayRemoteEndTime;	//ǰΰʱطŽʱ
	BOOL				m_iLocalPlayStepForward;	//زŲ
	BOOL				m_blBegainClip;				//Ƶ״̬
	bool				m_bPlaying;                 //Ƿڲ
	bool				m_blTempLocalPlayAdjust;	//ػطţ϶λС
	int					m_iLogonID;                 //¼id
	int					m_iTotalChannel;			//ͨ
	int					m_iTotalFile;               //ļ
	int					m_iCurrentFile;             //ļ
	int					m_iTotalPage;               //ҳ
	int					m_iCurrentPage;             //ǰҳ
	int					m_iDownloadCount;           //еļ
	int					m_iItemOfDownload[10];      //ص
	int					m_iLocalPlayFastValue;		//زſȼ
	int					m_iLocalPlaySlowValue;		//زȼ
	int					m_iLocalPlayStatus;			//ǰ״̬ 1-ͣ0-ţ-1-ǰΪ򲽽״̬

protected:
	virtual void DoDataExchange(CDataExchange* pDX);    
	DECLARE_MESSAGE_MAP()

public:
	//CSwallow m_PlaybackSwallowOcx;

	CSwallow* m_pSwallowPlayback;

	CListCtrl m_FileList;
	CComboBox m_CboStream;
	CComboBox m_CboChannelNo;
	CDateTimeCtrl DataTime_Start;
	CDateTimeCtrl DataTime_End;
	CDateTimeCtrl DataTime_StartTime;
	CDateTimeCtrl DataTime_EndTime;
	CDateTimeCtrl StartTimespan;
	CDateTimeCtrl StopTimespan;
	CDateTimeCtrl GotoTimeSpan;
	CProgressCtrl m_PlayProgress;

public:
	/***************************************************************
	ƣQueryRecordFile
	ѯ¼
	_iPageNo:ҳ
	
	    أ 
	    2011-05-13 11:46:42
	***************************************************************/
	void QueryRecordFile(int _iPageNo);

	/***************************************************************
	ƣGetPlayBackProgress
	õŽȣ1-100
	_iObsId:Ŵid
	
	    أŽ 
	    2011-05-13 11:47:38
	***************************************************************/
	int GetPlayBackProgress(int _iObsId);

    /***************************************************************
	ƣPlay
	ʼط
	_lobsIdID  _lLongonId¼Id
	          _lFileSrcļԴ 0  1Զ
			  _szFileNameļ _lIndexѯصֵ
	
	    أ0ɹ  ʧ 
	    2011-05-16 09:05:19
	***************************************************************/
	int Play(long _lobsId, long _lLongonId, long _lFileSrc, CString _szFileName, long _lIndex);

	/***************************************************************
	ƣPlayLocalFile
	߲űļ
	_lobsIdId   _szFileNameļ
	
	    أ0ɹ  ʧ 
	    2011-05-16 09:42:42
	***************************************************************/
	int PlayLocalFile(long _lobsId, CString _szFileName);

	/***************************************************************
	ƣEnableSomeControl
	û߽ĳЩؼ
	_blEnableǷ
	
	    أ 
	    2011/5/17 11:48:34
	***************************************************************/
	void EnableSomeControl(BOOL _blEnable);
	void QueryResultSwallowctrl1(long _lLogonID, LPCTSTR _bstrResult);
	void OnDownLoadSwallowctrl1(unsigned long _ulDLID, unsigned long _ulMsg);
	void OnPlayBackSwallowctrl1(long _ObsID, long _Event);
	void OnPlayBackDecryptSwallowctrl1(unsigned long _lobsId, unsigned long _lNotifyType);
	void OnRemoteDecryptSwallowctrl1(unsigned long _lObsId, unsigned long _lNotifyType);
	void SecondToHour(int _iSecond, CString* _csDstBuffer);
	void UpdatePlayingTimeByFile();
	void StopPlayInitVulue();
	void InitStreamCbo();
	void UpdatePlayingTimeByTime();

public:
	DECLARE_EVENTSINK_MAP()
	virtual BOOL OnInitDialog();
	virtual BOOL PreTranslateMessage(MSG* pMsg);
	afx_msg void OnBnClickedButtonDownload();
	afx_msg void OnBnClickedButtonPlaybyfile();
	afx_msg void OnBnClickedButtonFirstpage();
	afx_msg void OnBnClickedButtonPrepage();
	afx_msg void OnBnClickedButtonNextpage();
	afx_msg void OnBnClickedButtonLastpage();
	afx_msg void OnBnClickedButtonStopdownload();
	afx_msg void OnBnClickedButtonStopplaybyfile();
	afx_msg void OnBnClickedButtonQuery();
	afx_msg void OnTimer(UINT_PTR nIDEvent);
	afx_msg void OnLvnItemchangedListFile(NMHDR *pNMHDR, LRESULT *pResult);
	afx_msg void OnClose();
	afx_msg void OnBnClickedButtonPlaylocal();
	afx_msg void OnNMCustomdrawSliderProgress(NMHDR *pNMHDR, LRESULT *pResult);
	afx_msg void OnBnClickedButtonDec();
	afx_msg void OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar);
	afx_msg void OnBnClickedBtnLocalplaySlowvideo();
	afx_msg void OnBnClickedBtnLocalplayFastvideo();
	afx_msg void OnBnClickedBtnLocalplayPlayPause();
	afx_msg void OnBnClickedBtnLocalplayStepvideo();
	afx_msg void OnBnClickedBtnStopLocalplay();
	afx_msg void OnBnClickedBtnLocalplayCapturePic();
	afx_msg void OnBnClickedBtnLocalplayCaptureFile();
	afx_msg void OnBnClickedChkVoluemStart();
	afx_msg void OnBnClickedBtnPbkByTime();
	afx_msg void OnBnClickedBtnLocalplaySeek();
};
