
// OCXPlayDemoDlg.h : header file
//

#pragma once
#include "swallow.h"
#include "afxwin.h"
#include "afxcmn.h"

#include "CommonDef.h"
#include "FileQueryDlg.h"
#include <map>
using namespace std;


// COCXPlayDemoDlg dialog
class COCXPlayDemoDlg : public CDialog
{
// Construction
public:
	COCXPlayDemoDlg(CWnd* pParent = NULL);	// standard constructor

// Dialog Data
	enum { IDD = IDD_OCXPLAYDEMO_DIALOG };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support


// Implementation
protected:
	HICON m_hIcon;

	// Generated message map functions
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	DECLARE_MESSAGE_MAP()
public:
	/***************************************************************
	ƣInitDlg
	ʼǰĽʼ
	
	
	    أvoid 
	    2011-05-09 08:46:06
	***************************************************************/
	void InitDlg();

	/***************************************************************
	ƣCatchPic
	ץͼ
	_lobsIdƵĴid
	          _szFileNameļ
              _lPicQualityͼƬ1-100ĬΪ50
	
	    أ0: ɹ
	          ʧ
	    2011-05-12 16:32:30
	***************************************************************/
    int  CatchPic(long _lobsId, CString _szFileName, long _lPicQuality);

	/***************************************************************
	ƣStartRecord
	ʼ¼
	_lobsIdƵid  
	          _szFileNameļ(׺) demoڴ0Զ
	          _lPakTimeʱ䣨10-120λ
              _lPackSizeС  _lPakTimeΪ0ʱЧλMB
	
	    أ0ɹ
	          ʧ
	    2011-05-12 16:35:39
	***************************************************************/
	int  StartRecord(long _lobsId, CString _szFileName, long _lPakTime, long _lPackSize);

	/***************************************************************
	ƣStopRecord
	ֹͣ¼
	_lobsIdƵID
	
	    أ0ɹ
	          ʧ
	    2011-05-12 16:36:24
	***************************************************************/
	int  StopRecord(long _lobsId);

	/***************************************************************
	ƣEnableAudio
	ƵԤ
	_lobsIdƵid 
	          _iEnable1 
	                    0 ر
	
	    أ0ɹ
	          ʧ
	    2011-05-12 16:45:58
	***************************************************************/
	int  EnableAudio(long _lobsId, int _iEnable);

	/***************************************************************
	ƣSetVolume
	
	_lVolumeSizeֵ
	
	    أ0ɹ
	          ʧ
	    2011-05-12 16:47:19
	***************************************************************/
	int  SetVolume(long _lVolumeSize);

	/***************************************************************
	ƣUpdateFrameInfo
	´_iFrame״̬Ϣ
	_iFrame:ڱʶ -1:״̬
	
	    أvoid 
	    2011-05-09 08:45:25
	***************************************************************/
	void UpdateDeviceInfo(int _iFrame);

	/***************************************************************
	ƣGetDeviceProp
	õ豸Ϣ
	
	pConnState豸Ϣṹ
	    أ 
	    2011-05-12 16:37:34
	***************************************************************/
	void GetDeviceProp(CONNECT_STATE *pConnState);

	/***************************************************************
	ƣSetOSD
	osd
	_iFrameƵid
	
	    أ 
	    2011-05-12 16:38:12
	***************************************************************/
	void SetOSD(int _iFrame);

	/***************************************************************
	ƣSetControlDeviceInfo
	ǰ豸Ϣ
	_iFrameƵid
	
	    أ 
	    2011-05-12 16:38:47
	***************************************************************/
	void SetControlDeviceInfo(int _iFrame);

	/***************************************************************
	ƣGetControlDeviceInfo
	õǰ豸Ϣ
	_iFrameƵid
	
	    أ 
	    2011-05-12 16:39:12
	***************************************************************/
	void GetControlDeviceInfo(int _iFrame);

	/***************************************************************
	ƣDevControl
	豸
	_iMove: Ʋ
	
	    أ0ɹ
	          ʧ
	    
	***************************************************************/
	int DevControl(int _iMove);

	/***************************************************************
	ƣGetVideopara
	õƵ
	_iFrameƵid
	
	    أ 
	    2011-05-12 16:40:39
	***************************************************************/
	void GetVideopara(int _iFrame);

	/***************************************************************
	ƣAppendMsg
	ӡϢ
	_strMsgӡϢ
	
	    أ 
	    2011-05-12 16:41:12
	***************************************************************/
	void AppendMsg(CString& _strMsg);

	/***************************************************************
	ƣEnableTalk
	Խʹ
	_iLogonId¼id 
	          _iEnbale1 ʼԽ  
			            0 ֹͣԽ
	
	    أ0ɹ
	          ʧ
	    2011-05-12 16:42:27
	***************************************************************/
	int EnableTalk(int _iLogonId, int _iEnbale);

	/***************************************************************
	ƣGetOsdText
	õosdַ
	_iLogonId¼id  _iChannelNo:ͨ
	
	    أosdַ 
	    2011-05-13 09:01:37
	***************************************************************/
	CString GetOsdText(int _iLogonId, int _iChannelNo);

	/***************************************************************
	ƣSetOsdText
	osdַ
	_iLogonId¼id  _iChannelNo:ͨ
	          _szOsdText:osdı _iTextColor:ıɫ
	
	    أ0ɹ
	          ʧ
	    2011-05-13 09:01:37
	***************************************************************/
	int SetOsdText(int _iLogonId, int _iChannelNo, CString _szOsdText, int _iTextColor);

	/***************************************************************
	ƣObsShowMessage
	СʾʾϢ
	_lobsIdID  _blShowǷʾ  _szMessageϢ
	          _iMs:ʾʱ䣨λ룩
	
	    أ0ɹ  ʧ 
	    2011-05-13 10:00:45
	***************************************************************/
	int ObsShowMessage(long _lobsId, bool _blShow, CString _szMessage, int _iMs);

	/***************************************************************
	ƣ
	
	
	
	    أ 
	    
	***************************************************************/
	int DecryptVideo(long _lLogonId, int _iChannelNo, CString _szKey, int _iKeyLen);

	/***************************************************************
	ƣGetActionNoAndPara
	תϢ
	_iMove  _iSpeed:ٶ  _iPreset:Ԥλ
	_iAction:ת  _iPara11  _iPara22
	    أ 0ɹ
	    2011-05-12 16:44:04
	***************************************************************/
	int GetActionNoAndPara(int _iMove, int _iSpeed, int _iPreset, int &_iAction, int &_iPara1, int &_iPara2);

//Swallow¼
public:
	void LogonMsgSwallow(long lLogStatus, long _lLogonID);
	void OnObsClickedSwallow(unsigned long _ulObsID);
	void StartPlaySwallow(long _lResult, unsigned long _ulConnID);	
	void OnTalkSwallow(unsigned long _LogonID, unsigned long _State);
	void OnConnectDecryptSwallow(unsigned long _lLogonID, unsigned long _ulChannel, unsigned long _lNotifyType);
public:
	//max obs
	const static int CONST_iFrameNum = 16;
    //obsid array
    long  m_lconnectId[CONST_iFrameNum];
	//if the obs rec 
	bool  m_blRecord[CONST_iFrameNum];
    //if the obs audio
	bool  m_blAudio[CONST_iFrameNum];
    //queryfile dialog
	CFileQueryDlg* m_FileQueryDlg;
	//store frame id 
	long m_lObsID[16];
	//each frame connect info
	map<long, CONNECT_STATE> m_map_connectInfo;
	//current connect info
	CONNECT_STATE m_conCurrent;
	// swallow ocx

	CSwallow* m_pSwallowOcxMain;
	// select frames
	CComboBox m_cboFrames;
	// the control of device ip
	CIPAddressCtrl m_DeviceIPCtl;
	// the control of proxy ip
	CIPAddressCtrl m_ProxyIPCtl;
	// the control of channel
	CComboBox m_cboChannelCtl;
	// the control of mode
	CComboBox m_cboModeCtl;
	// the control of stream
	CComboBox m_cboStreamCtl;
	// the control of id
	CEdit m_edtIDCtl;
	// the control of volume
	CSliderCtrl m_sldVolume;
	//EZoom State
	BOOL	m_iEzoomEnable;
	//Audio connnect state
	CButton m_chkAudio;
	afx_msg void OnBnClickedButtonLogon();
	afx_msg void OnBnClickedButtonConnect();
	afx_msg void OnCbnSelchangeComboFrames();
	DECLARE_EVENTSINK_MAP()
	afx_msg void OnBnClickedButtonPicture();
	afx_msg void OnBnClickedButtonLogoff();
	afx_msg void OnBnClickedButtonDisconnect();
	afx_msg void OnBnClickedButtonRecord();
	afx_msg void OnBnClickedBtnConfig();
	afx_msg void OnBnClickedButtonFilequery();
	afx_msg void OnBnClickedButtonOsd();
	afx_msg void OnBnClickedButtonDevicetypeset();
	afx_msg void OnBnClickedButtonHorauto();
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnLButtonUp(UINT nFlags, CPoint point);
	afx_msg void OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar);
	virtual BOOL PreTranslateMessage(MSG* pMsg);
	afx_msg void OnBnClickedButtonGotpreset();
	afx_msg void OnBnClickedButtonSetpreset();
	afx_msg void OnNMCustomdrawSliderBrightness(NMHDR *pNMHDR, LRESULT *pResult);
	afx_msg void OnNMCustomdrawSliderSaturation(NMHDR *pNMHDR, LRESULT *pResult);
	afx_msg void OnNMCustomdrawSliderContrast(NMHDR *pNMHDR, LRESULT *pResult);
	afx_msg void OnNMCustomdrawSliderHue(NMHDR *pNMHDR, LRESULT *pResult);
	afx_msg void OnNMCustomdrawSliderSpeed(NMHDR *pNMHDR, LRESULT *pResult);
	afx_msg void OnDestroy();
	afx_msg void OnBnClickedCheckPower();
	afx_msg void OnBnClickedCheckLight();
	afx_msg void OnBnClickedCheckRain();
	afx_msg void OnBnClickedButtonTalk();
	afx_msg void OnBnClickedButtonDecrypt();
	afx_msg void OnBnClickedBtnEzoom();
	afx_msg void OnBnClickedChkDecryptType();
	afx_msg void OnBnClickedVideoShowMode();
	afx_msg void OnBnClickedBtnFullScreen();
	afx_msg void OnBnClickedChkAudioPreview();
	CButton m_edtEZoomEnable;
	afx_msg void OnBnClickedBtnSetLocalTime();
};
