
#ifndef __SWALLOWTYPES_H_
#define __SWALLOWTYPES_H_

#define	LMSG_Logon						0x00000000
#define LMSG_Error						0x00000001
#define LMSG_DownLoad					0x00000002
#define LMSG_Init						0x00000003
#define LMSG_ObsClicked					0x00000004
#define LMSG_ParaChg					0x00000005
#define LMSG_QueryRst					0x00000006
#define LMSG_PlayBack					0x00000007
#define LMSG_StartPlay					0x00000008
#define LMSG_SysInfo					0x00000009
#define LMSG_UpProg						0x0000000a
#define LMSG_UpWeb						0x0000000b
#define LMSG_Talk						0x0000000c
#define LMSG_RecErr						0x0000000d
#define LMSG_DownLoadLog				0x0000000e
#define LMSG_Backup     				0x0000000f
#define LMSG_LocalStoreProg  			0x00000010
#define LMSG_DiskFormatProg             0x00000011
#define LMSG_FormatErr                  0x00000012
#define LMSG_PartErr                    0x00000013 
#define LMSG_QueryRstlog  			    0x00000014

#define LMSG_PLAYBACK_NEED_DECRYPT_KEY	0x00000015	
#define LMSG_PLAYBACK_DECRYPT_KEY_FAILED	0x00000016	
#define LMSG_PLAYBACK_DECRYPT_SUCCESS	0x00000017	
#define LMSG_DECRYPT                    0x00000018

#define LMSG_QueryRstJson				0x00000019	//ѯ¼ļjsonʽϢ
#define LMSG_DevConnectInfo				0x0000001a	//豸ӵϢ
#define LMSG_HBRealData					0x0000001b	//豸Ѫѹ
#define LMSG_GraphData					0x0000001c	//豸Ĳ
#define LMSG_MicroValue					0x0000001e	//

#define LMSG_RebuilderIndex				0x0000001f	//ؽ
#define LMSG_ChannelChange				0x00000020	//ͨŷ仯

//////////////////////////////////////////////////////////////////////////
//command code

#define Sys_Cleanup_Cmd					0x00000001
#define Sys_LocalTime_Set				0x00000002
#define Sys_Restore_Cmd					0x00000003
#define Sys_Reboot_Cmd					0x00000004
#define Sys_AdjustLayout_Cmd			0x00000005
#define	Sys_FullScreen_Cmd				0x00000006
#define Sys_UpgradePro_Cmd				0x00000007
#define Sys_UpgradeWebPage_Cmd			0x00000008
#define Sys_UpgradeProgress_Get			0x00000009
#define Sys_SysInfo_Get					0x0000000a
#define	Sys_Style_Set					0x0000000b
#define Sys_Backup_Cmd                  0x0000000c
#define Sys_Shutdown_Cmd				0x0000000d
#define Sys_LocalConfigInfo_Set 		0x0000000e	 //Ϣ
#define Sys_LocalConfigInfo_Get 		0x0000000f	 //Ϣȡ



#define Entry_Logon_Cmd					0x00010000
#define Entry_Logoff_Cmd				0x00010001	 //¼豸
#define Entry_Prop_Get					0x00010002	 //ע豸
#define Entry_NVSList_Get				0x00010003
#define Entry_NVSVer_Get				0x00010004
#define Entry_ObsLst_Get				0x00010005
#define Entry_Volume_Set                0x00010006    // Ԥ
#define Entry_Config_Get                0x00010007
#define Entry_LoginStatus_Get           0x00010008

#define Obs_Prop_Get					0x00020000
#define Obs_FullScreen_Cmd				0x00020001
#define Obs_Add_Cmd						0x00020002
#define Obs_Remove_Cmd					0x00020003
#define Obs_StartRealTime_Cmd			0x00020004
#define Obs_StartPlayBack_Cmd			0x00020005
#define Obs_Pause_Cmd					0x00020006
#define Obs_FastForward_Cmd				0x00020007
#define Obs_SlowForward_Cmd				0x00020008
#define Obs_Stop_Cmd					0x00020009
#define Obs_ShowParam_Cmd				0x0002000a
#define Obs_MicEnable_Set				0x0002000b
#define Obs_SpeakerEnable_Set			0x0002000c   //ñƵʹܣNVSͨƵ
#define Obs_Capture_Cmd					0x0002000d   //ץƵǰץĵͼƬΪJPEGʽֱӴ洢ǰ˵Ĵ洢豸УץĵΪBMPʽ洢λStore_LocalPath_SetָļĴС
#define Obs_BeginRec_Cmd				0x0002000e
#define Obs_EndRec_Cmd					0x0002000f
#define Obs_Progress_Get				0x00020010   //ȡŽ ֻ¼ط
#define Obs_ShowMsg_Cmd		 			0x00020011	 //ƵʾϢ
#define	Obs_Volume_Set					0x00020012   // ط
#define	Obs_Volume_Get					0x00020013   //ȡֵֻԻطЧ
#define Obs_Monopolize_Cmd				0x00020014
#define Obs_StartPlayBackOffLine_Cmd	0x00020015
#define Obs_3dLocateEnable_Set			0x00020016
#define Obs_3dLocateEnable_Get			0x00020017
#define Obs_StopPause_Set				0x00020018
#define Obs_LocalCapture_Cmd			0x00020019
#define Obs_LocalCaptureRead_Cmd		0x00020020
#define Obs_PlayBackSeek_Cmd			0x00020021   //طŶλ
#define Obs_PlayBackPause_Cmd			0x00020022   //طͣ
#define Obs_PlayBackTotalTime_Get		0x00020023   //طŵʱ
#define Obs_PlayBackNormal_Set			0x00020024   //ٻطʱָٶ
#define Obs_PlayBackCurTime_Get			0x00020025   //طŵĵǰʱ
#define Obs_PlayBack_PlayAudio			0x00020026   ///رջطŵƵ
#define Obs_Progress_Set                0x00020027   //¼㲥طʱòŽ
#define Obs_EZoomEnable_Set             0x00020028   //õӷŴʹܣѡзŴ
#define Obs_EZoomEnable_Get             0x00020029   //ȡӷŴʹܹ
#define Obs_MarkIfo_Get					0x00020030	 //¼ļеĴϢҪȵstartplayback_cmdObs_StartPlayBackOffLine_Cmd
#define Obs_PlayBack_SeekMark			0x00020031	 //طʱȷλ߱ػط
#define Obs_MarkIfo_Set					0x00020032	 //ÿ¼ʱϢ
#define Obs_CDBurn_Status_Get			0x00020033   //ÿ¼״̬Ϣ 
#define Obs_FastBackward_Cmd			0x00020034   //طſ
#define Obs_Enable_DecryptTip			0x00020035	 //ƵʱǷ񵯳
#define Obs_VideoEncrypt_Set			0x00020037	 //ʵʱƵ
#define Obs_Attach_File					0x00020038	 //¼
#define Obs_SetFile						0x00020039	 //ļţGetļϢ
#define Obs_GetTotalFrame				0x00020040	 //ȡTotalFrame÷ʽObs_Progress_Get
#define Obs_GetSdvConvertInfo			0x00020041	 //ڶSDVתɵһļMP4ȡԭÿSDVĿʼʱͽʱ䣬ӿڲļڲļ
#define Obs_GetSdvConvertInfoByFile		0x00020042	 //ڶSDVתɵһļMP4ȡԭÿSDVĿʼʱͽʱ䣬ӿڴļ
#define Obs_KeyFrame_Get				0x00020043	 //ȡϢ
#define Obs_ShowVitalSignLine			0x00020044	 //Ƿʾ
#define Obs_HasVitalSignLineData		0x00020045	 //ȡǷ
#define Obs_AddBtn_Cmd					0x00020046   //ʾȫť
//add by psb 2015.8.15
#define Obs_CombineChildActive			0x00020047	 //ϳͨӻŴʹ
//end add
#define Obs_VideoEncrypt_Get            0x00020048	 //ȡʵʱƵ
#define Obs_LeftDbClick_Set	            0x00020049	 //Ƿ֧˫ȫ
#define Obs_StopWave					0x00020050	 //Ƶε
#define Obs_ShowWave					0x00020051	 //Ƶεʾ

//Web6.0 zyb add 20160106
#define Obs_Init_Cmd  					0x00020052	 //ʼ
#define Obs_RecStatusc_Get     			0x00020053	 //ȡ¼״̬ 0:δ¼ 1:¼
#define Obs_PreviewStatus_Get  			0x00020054	 //ȡԤƵ״̬ 0:δ 1:
#define Obs_TalkStatus_Get         		0x00020055	 //Խ״̬
#define Obs_CurObsInfo_Get      		0x00020056	 //ȡǰϢ
#define Obs_VideoShowMode_Set    		0x00020057	 //Ƶʾģʽ 1̶ 0Ӧ
#define Obs_VideoShowMode_Get    		0x00020058	 //ȡƵʾģʽ 1̶ 0Ӧ
#define Obs_ShowBitrate_Set    			0x00020059	 //Ƿʾ֡ 0:ʾ  1:ʾ
#define Obs_ShowBitrate_Get    			0x00020060	 //ȡǷʾ֡ 0:ʾ  1:ʾ
#define Obs_CurWindowMode_Set 			0x00020061	 //õǰģʽ 0:Ԥ 1:ط 2:
#define Obs_CurWindowMode_Get			0x00020062	 //ȡǰģʽ 0:Ԥ 1:ط 2:
#define Obs_StepForward_Cmd 			0x00020063	 //
#define Obs_PlayBackPos_Get 			0x00020064	 //ȡطŽ
#define Obs_StartPlayBackByTime_Cmd		0x00020065	 //ʱλط
#define Obs_RecStatus_Get				0x00020066	 //ȡ¼״̬
#define Obs_StartDraw_Cmd				0x00020067	 //ƵϿʼ
#define Obs_StopDraw_Cmd				0x00020068	 //Ƶֹͣ
#define Obs_DrawColor_Cmd				0x00020069	 //Ƶϻɫ
#define Obs_ClearDraw_Cmd				0x00020070	 //Ƶ
#define Obs_GetDraw_Cmd					0x00020071	 //Ƶϻȡ
#define Obs_SetDraw_Cmd					0x00020072	 //Ƶû

//end 

#define Dev_Type_Set					0x00030000
#define Dev_Type_Get					0x00030001
#define Dev_AllType_Get					0x00030002
#define Dev_Controllable_Get			0x00030003
#define Dev_Control_Cmd					0x00030004   //͸ͨ
#define Dev_Model_Get					0x00030005
#define Dev_Device_Ctrl					0x00030006   //Эģʽ
#define Dev_FuncListArray_Set			0x00030007
#define Dev_FuncListArray_Get			0x00030008
#define Dev_DeviceType_Set				0x00030009
#define Dev_DeviceType_Get				0x0003000a
#define Dev_SetComFormat_Set			0x0003000b
#define Dev_SetComFormat_Get			0x0003000c
#define Dev_CHNPTZCRUISE_Set			0x0003000d
#define Dev_CHNPTZCRUISE_Get			0x0003000e
#define Dev_CHNPTZCRUISEPLAY_Set		0x0003000f
#define Dev_ChannelCount_Get			0x00030010	//ͨ
#define Dev_ConnectInfo_Get				0x00030011	//豸Ϣ
#define Dev_FactoryID_Get				0x00030012  //ȡ豸кFactory ID
#define Dev_ComPortCounts_Get			0x00030013	//ȡ豸
#define Dev_VideoInputMode_Set			0x00030014	//豸ò
#define Dev_VideoInputMode_Get			0x00030015	//ȡ豸ò
#define Dev_CDBurn_Control				0x00030016  //¼ƽӿڣʵֿʼ¼ֹͣ¼
#define Dev_Disk_Count					0x00030017	//ôܸ
#define Dev_Set_Life_Feature_UploadCenterOSD	0x00030018	//ϴĺַ
#define Dev_Get_Life_Feature_UploadCenter		0x00030019
#define Dev_Get_Life_Feature_Data		0x00030020	//ȡ
#define Dev_Get_Life_Feature_Graph		0x00030021	//ȡ
#define Dev_Show_Graph					0x00030022	//Ƿʾ
#define Dev_Get_Burn_Mode				0x00030023	//ÿ¼ģʽ
#define Dev_Get_Http_Port				0x00030024	//Web˿
#define Dev_Get_Server_Version			0x00030025	//ϵͳ汾Ϣ
#define Dev_GetPopCloseDiskFlags		0x00030026	//÷̺͵̱־λ
#define Dev_Get_Chl_Name				0x00030027	//ͨ

#define Alarm_MDEnable_Set				0x00040000
#define Alarm_MDEnable_Get				0x00040001
#define Alarm_MDThreshold_Set			0x00040002
#define Alarm_MDThreshold_Get			0x00040003
#define Alarm_MDArea_Get				0x00040004
#define Alarm_MDClean_Cmd				0x00040005
#define Alarm_VCEnable_Set				0x00040006
#define Alarm_VCEnable_Get				0x00040007
#define Alarm_VCThreshold_Set			0x00040008
#define Alarm_VCThreshold_Get			0x00040009
#define Alarm_VCArea_Set				0x0004000a
#define Alarm_VCArea_Get				0x0004000b
#define Alarm_VCClean_Cmd				0x0004000c
#define Alarm_VLEnable_Set				0x0004000d  //Ƶʧ
#define Alarm_VLEnable_Get				0x0004000e	//öʧ״̬
#define Alarm_PortCnt_Get				0x0004000f
#define Alarm_InputEnable_Set			0x00040010
#define Alarm_InputEnable_Get			0x00040011
#define Alarm_InputMode_Set				0x00040012
#define Alarm_InputMode_Get				0x00040013
#define Alarm_Link_Set					0x00040014
#define Alarm_Link_Get					0x00040015
#define Alarm_OutputMode_Set			0x00040016
#define Alarm_OutputMode_Get			0x00040017
#define Alarm_EmailEnable_Set			0x00040018
#define Alarm_EmailEnable_Get			0x00040019
#define Alarm_EmailInfo_Set				0x0004001a
#define Alarm_EmailInfo_Get				0x0004001b
#define Alarm_DrawEnable_Set			0x0004001c
#define Alarm_DrawEnable_Get			0x0004001d
#define Alarm_Server_Set				0x0004001e
#define Alarm_Server_Get				0x0004001f
#define Alarm_Schedule_Set				0x00040020
#define Alarm_Schedule_Get				0x00040021
#define Alarm_OutPortDelay_Set			0x00040022
#define Alarm_OutPortDelay_Get			0x00040023
#define Alarm_LinkRec_Set				0x00040024  //Ƶʧ¼
#define Alarm_LinkRec_Get				0x00040025  //Ƶʧ˿
#define Alarm_LinkSnap_Set				0x00040026  
#define Alarm_LinkSnap_Get				0x00040027  
#define Alarm_LinkOutPort_Set			0x00040028
#define Alarm_LinkOutPort_Get			0x00040029
#define Alarm_LinkPTZ_Set				0x0004002a  //ƵʧPTZ
#define Alarm_LinkPTZ_Get				0x0004002b  //ƵʧPTZ
#define Alarm_InPortEnable_Set			0x0004002c
#define Alarm_InPortEnable_Get			0x0004002d
#define Alarm_OutPortEnable_Set			0x0004002e
#define Alarm_OutPortEnable_Get			0x0004002f
#define	Alarm_OutPortState_Set			0x00040030
#define Alarm_StartPicStream			0x00040031	//ͼƬ
#define Alarm_StopPicStream				0x00040032	//ͼƬر
#define Alarm_GetPicStreamInfo			0x00040033	//ͼƬͼƬϢѯ


#define User_MaxConn_Set				0x00050000
#define User_MaxConn_Get				0x00050001
#define User_UserList_Get				0x00050002
#define User_AddUser_Cmd				0x00050003
#define User_DelUser_Cmd				0x00050004
#define User_ModifyPwd_Cmd				0x00050005

#define Osd_Type_Set					0x00060000
#define Osd_Type_Get					0x00060001
#define Osd_Text_Set					0x00060002
#define Osd_Text_Get					0x00060003
#define Osd_TextEx_Set					0x00060004
#define Osd_TextEx_Get					0x00060005
#define Osd_PicRead_Cmd 				0x00060006
#define Append_Osd_Set_By_Rate			0x00060007 //ַͨ
#define Append_Osd_Set					0x00060008 //ַ
#define Osd_DateFormat_Get			    0x00060009 
#define Osd_OSDTypeFontSize_Set 		0x0006000a
#define Osd_OSDTypeFontSize_Get			0x0006000b 
#define Osd_DateFormat_Set 				0x0006000c
#define Osd_LocationType_Set			0x0006000d	 //ַԶλã1=ͨ 2=

#define Video_StreamType_Set			0x00070000
#define Video_StreamType_Get			0x00070001
#define Video_MaxSize_Get				0x00070002
#define Video_FrameRate_Set				0x00070003
#define Video_FrameRate_Get				0x00070004
#define Video_Display_Set				0x00070005
#define Video_Display_Get				0x00070006
#define Video_Quality_Set				0x00070007
#define Video_Quality_Get				0x00070008
#define Video_KbitRate_Set				0x00070009
#define Video_KbitRate_Get				0x0007000a
#define Video_Size_Set					0x0007000b
#define Video_Size_Get					0x0007000c
#define Video_Encode_Set				0x0007000d
#define Video_Encode_Get				0x0007000e
#define Video_NP_Set					0x0007000f
#define Video_NP_Get					0x00070010
#define Video_Scene_Set					0x00070011
#define Video_Scene_Get					0x00070012
#define Video_Reverse_Set				0x00070013
#define Video_Reverse_Get				0x00070014
#define Video_Mirror_Set				0x00070015
#define Video_Mirror_Get				0x00070016
#define Video_PreferMode_Set			0x00070017
#define Video_PreferMode_Get			0x00070018
#define Video_DisplaySchedule_Set		0x00070019
#define Video_DisplaySchedule_Get		0x0007001a
#define Video_IFrameRate_Set			0x0007001b
#define Video_IFrameRate_Get			0x0007001c
#define Video_MaxMinorSize_Get			0x0007001d
#define Video_VencType_Set				0x0007001e
#define Video_VencType_Get				0x0007001f
#define Video_ShowFrameMode_Set			0x00070020
#define Video_ShowFrameMode_Get			0x00070021
#define Video_AdjustBitRateShow_Set		0x00070022
#define Video_AdjustBitRateShow_Get		0x00070023
#define Video_SetModeRule				0x00070024  //Ƶ
#define Video_ChannelProperty_Set		0x00070025  //ͨ
#define Video_ChannelProperty_Get		0x00070026  //ͨ
#define Video_DigitalChannelConfig_Set	0x00070027  //ͨ
#define Video_DigitalChannelConfig_Get	0x00070028  //ȡͨ
#define Video_CombineParam_Set			0x00070029	//ûϳɲ
#define Video_CombineParam_Get			0x00070030	//ȡϳɲ
#define Video_VcAffinal_Set				0x00070031	//úϳɻ
#define Video_VcAffinal_Get				0x00070032	//ȡϳɻ 
#define Video_Size_Get_Width_Hight		0x00070033  //Ƶ

#define Audio_Chann_Set					0x00080000
#define Audio_Chann_Get					0x00080001
#define Audio_Encoder_Set				0x00080002
#define Audio_Encoder_Get				0x00080003
#define Audio_MixParam_Set				0x00080004	//Ƶϲ
#define Audio_MixParam_Get				0x00080005	//ȡƵϲ
#define Audio_Volume_Set				0x00080006	//Ʋ
#define Audio_Volume_Get				0x00080007	//ȡƲ
#define Audio_MircoValue_Get			0x00080008	//ȡֵ

#define Audio_Sample_Set			    0x00080009	//Ƶ
#define Audio_Sample_Get			    0x0008000a	//ȡƵ

#define Query_Query_Cmd					0x00090000

#define Store_LocalPath_Set				0x000a0001
#define Store_LocalPath_Get				0x000a0002
#define Store_RmtRecExt_Set				0x000a0003
#define Store_RmtRecExt_Get				0x000a0004
#define Store_ManualRecOnRmt_Cmd		0x000a0005
#define Store_RmtRecRule_Set			0x000a0006
#define Store_RmtRecRule_Get			0x000a0007
#define Store_RmtAlmRecPara_Set			0x000a0008
#define Store_RmtAlmRecPara_Get			0x000a0009
#define Store_RmtAlmRecEnable_Set		0x000a000a
#define Store_RmtAlmRecEnable_Get		0x000a000b
#define Store_RmtSchRecPara_Set			0x000a000c
#define Store_RmtSchRecPara_Get			0x000a000d
#define Store_RmtSchRecEnable_Set		0x000a000e
#define Store_RmtSchRecEnable_Get		0x000a000f
#define Store_RmtRecStat_Get			0x000a0010
#define Store_DLStart_Cmd				0x000a0011
#define Store_DLStop_Cmd				0x000a0012
#define Store_DLProgress_Get			0x000a0013
#define Store_RmtIsSupport_Get			0x000a0014
#define Store_RmtDiskInfo_Get			0x000a0015
#define Store_RmtDiskUsage_Set			0x000a0016
#define Store_RmtFormat_Cmd				0x000a0017
#define Store_RmtPart_Cmd				0x000a0018
#define Store_RmtRebuildIndex_Cmd		0x000a0019
#define Store_RmtDelFile_Cmd			0x000a001a
#define Store_RmtUsbState_Get			0x000a001b
#define Store_RmtMountUSB_Cmd			0x000a001c
#define Store_RmtMapDev_Get				0x000a001d
#define Store_RmtMapDev_Cmd				0x000a001e
#define Store_OpenLocFile_Cmd			0x000a001f
#define Store_Disk_Clear_Cmd			0x000a0020

#define Net_NVSAddr_Set					0x000b0000
#define Net_NVSAddr_Get					0x000b0001
#define Net_DomainProp_Set				0x000b0002
#define Net_DomainProp_Get				0x000b0003
#define Net_PPPoEProp_Set				0x000b0004
#define Net_PPPoEProp_Get				0x000b0005
#define Net_HttpProp_Set				0x000b0006
#define Net_HttpProp_Get				0x000b0007
#define Net_IPFilter_Set				0x000b0008
#define Net_IPFilter_Get				0x000b0009
#define Net_WifiPara_Set				0x000b000a
#define Net_WifiPara_Get				0x000b000b
#define Net_WifiSrch_Cmd				0x000b000c
#define Net_WifiSrchRst_Get				0x000b000d
#define Net_UPNPEnable_Set				0x000b000e
#define Net_UPNPEnable_Get				0x000b000f
#define Net_WifiDhcpEnable_Set			0x000b0010
#define Net_WifiDhcpEnable_Get			0x000b0011
#define Net_DDNSPara_Set				0x000b0012
#define Net_DDNSPara_Get				0x000b0013

#define Log_DownLoad_Cmd				0x000c0000
#define Log_Read_Cmd					0x000c0001
#define Log_Clear_Cmd					0x000c0002
#define Log_Query_Cmd					0x000c0003

#define ZTE_ZTEInfo_Set					0x000d0001
#define ZTE_ZTEInfo_Get					0x000d0002
#define ZTE_OnlineState_Set				0x000d0003
#define ZTE_OnlineState_Get				0x000d0004

#define PU_ManagerServersInfo_Set		0x000e0001
#define PU_ManagerServersInfo_Get		0x000e0002
#define PU_DeviceID_Set					0x000e0003
#define PU_DeviceID_Get					0x000e0004
#define PU_NTP_Set						0x000e0005
#define PU_NTP_Get						0x000e0006	
#define PU_CPUMEMAlarm_Set				0x000e0007
#define PU_CPUMEMAlarm_Get				0x000e0008	
#define PU_OSDAlpha_Set					0x000e0009
#define PU_OSDAlpha_Get					0x000e000a	
#define PU_PTZAUTO_Set					0x000e000b
#define PU_PTZAUTO_Get					0x000e000c
#define PU_MD5_Cmd                      0x000e000d
#define PU_ListenPort_Set				0x000e000e
#define PU_ListenPort_Get				0x000e000f

#define DZ_COMMON_Set					0x000f0001
#define DZ_COMMON_Get					0x000f0002

#define Com_Server_Set					0x000f0003
#define Com_Server_Get					0x000f0004

#define G_DeviceStatus_Get				0x000f0005
#define G_Dialog_Set					0x000f0006
#define G_Dialog_Get					0x000f0007
#define G_Message_Set					0x000f0008
#define G_Message_Get					0x000f0009
#define G_TaskSchedule_Set				0x000f000a
#define G_TaskSchedule_Get				0x000f000b
#define G_Notify_Set					0x000f000c
#define G_Notify_Get					0x000f000d
#define G_VPDN_Set						0x000f000e
#define G_VPDN_Get						0x000f000f
#define DZ_COMMON_Set_Ex				0x000f0010	//ʹdispatchӿڣʹַݽṹ

#define HD_Camer_Set					0x00100001
#define HD_Camer_Get					0x00100002

#define User_WriteData_Set				0x00110001
#define User_ReadData_Get				0x00110002

#define NVR_ColorToGray_Set				0x00120001
#define NVR_ColorToGray_Get				0x00120002
#define NVR_CustomChannelName_Set		0x00120003
#define NVR_CustomChannelName_Get		0x00120004
#define NVR_CustomRecType_Set			0x00120005
#define NVR_CustomRecType_Get			0x00120006
#define NVR_FTPUpdate_Set				0x00120007
#define NVR_FTPUpdate_Get				0x00120008
#define NVR_CHNPTZFormat_Set			0x00120009
#define NVR_CHNPTZFormat_Get			0x0012000a
#define NVR_OSDTypeColor_Set			0x0012000b
#define NVR_OSDTypeColor_Get			0x0012000c
#define NVR_ExceptionMsg_Get			0x0012000d

#define NVR_FTPUsage_Set				0x0012000e
#define NVR_FTPUsage_Get				0x0012000f
#define NVR_FTPUploadConfig_Set			0x00120010
#define NVR_FTPUploadConfig_Get			0x00120011

#define ConnectInfor_Set				0x00130001
#define ConnectInfor_Get				0x00130002
#define LogonInfor_Set					0x00130003
#define LogonInfor_Get					0x00130004

#define HD_Camer_GetEx					0x00130005
#define HD_Camer_SetEx					0x00130006
#define HD_Camer_ClearEx				0x00130007
#define HD_CamerSet_EX				    0x00130008
#define HD_CamerGet_EX				    0x00130009

#define SetSaveStatus					0x0013000a
#define GetSaveStatus					0x0013000b

#define DEVICE_DECRYPT_SET			    0x00140000
#define DEVICE_DECRYPT_GET			    0x00140001
#define DEVICE_DECRYPTREC_SET           0x00140002
#define DEVICE_DECRYPTREC_GET           0x00140003

#define NOT_SUPPORT_FASTBACKWARD		-3

//Product Model
#define PRODUCT_MODEL_S2_NS_1			0x0060
#define PRODUCT_MODEL_S2_NS_2			0x0061
#define PRODUCT_MODEL_S2_NS_4			0x0062
#define PRODUCT_MODEL_S2_NS_8			0x0064

#define PRODUCT_MODEL_355_NC_HD			0x0050
#define PRODUCT_MODEL_S2_NC_HD			0x0051
#define PRODUCT_MODEL_S2_NC_HD_2		0x0052

#define PRODUCT_MODEL_3511_DVR_8		0x0110
#define PRODUCT_MODEL_3511_DVR_16		0x0100
#define PRODUCT_MODEL_3520_DVR_16		0x0120
#define PRODUCT_MODEL_3520_DVR_16_1		0x0130
#define PRODUCT_MODEL_3520_DVR_16_2		0x0140

#define PRODUCT_MODEL_355_NC_HD			0x0050
#define PRODUCT_MODEL_S2_NC_HD			0x0051
#define PRODUCT_MODEL_S2_NC_HD_2		0x0052

#define PRODUCT_MODEL_3511_DVR_8		0x0110
#define PRODUCT_MODEL_3511_DVR_16		0x0100
#define PRODUCT_MODEL_3520_DVR_16		0x0120
#define PRODUCT_MODEL_3520_DVR_16_1		0x0130
#define PRODUCT_MODEL_3520_DVR_16_2		0x0140

#endif